=== renamed directory 'django/core/cache' => 'django/cache'
=== renamed file 'django/middleware/cache.py' => 'django/cache/middleware.py'
--- django/middleware/cache.py	2007-03-28 01:14:50 +0000
+++ django/cache/middleware.py	2007-05-15 05:04:07 +0000
@@ -1,6 +1,6 @@
 from django.conf import settings
-from django.core.cache import cache
-from django.utils.cache import get_cache_key, learn_cache_key, patch_response_headers
+from django.cache import cache
+from django.cache.utils import get_cache_key, learn_cache_key, patch_response_headers
 
 class CacheMiddleware(object):
     """

=== renamed file 'django/utils/cache.py' => 'django/cache/utils.py'
--- django/utils/cache.py	2007-05-02 01:31:02 +0000
+++ django/cache/utils.py	2007-05-15 05:06:43 +0000
@@ -13,13 +13,13 @@
 different header content for headers named in "Vary" need to get different
 cache keys to prevent delivery of wrong content.
 
-A example: i18n middleware would need to distinguish caches by the
+An example: i18n middleware would need to distinguish caches by the
 "Accept-language" header.
 """
 
 import datetime, md5, re
 from django.conf import settings
-from django.core.cache import cache
+from django.cache import cache
 
 cc_delim_re = re.compile(r'\s*,\s*')
 
@@ -116,7 +116,7 @@
         value = request.META.get(header, None)
         if value is not None:
             ctx.update(value)
-    return 'views.decorators.cache.cache_page.%s.%s.%s' % (key_prefix, request.path, ctx.hexdigest())
+    return 'cache.decorators.cache_page.%s.%s.%s' % (key_prefix, request.path, ctx.hexdigest())
 
 def get_cache_key(request, key_prefix=None):
     """
@@ -130,7 +130,7 @@
     """
     if key_prefix is None:
         key_prefix = settings.CACHE_MIDDLEWARE_KEY_PREFIX
-    cache_key = 'views.decorators.cache.cache_header.%s.%s' % (key_prefix, request.path)
+    cache_key = 'cache.decorators.cache_header.%s.%s' % (key_prefix, request.path)
     headerlist = cache.get(cache_key, None)
     if headerlist is not None:
         return _generate_cache_key(request, headerlist, key_prefix)
@@ -154,7 +154,7 @@
         key_prefix = settings.CACHE_MIDDLEWARE_KEY_PREFIX
     if cache_timeout is None:
         cache_timeout = settings.CACHE_MIDDLEWARE_SECONDS
-    cache_key = 'views.decorators.cache.cache_header.%s.%s' % (key_prefix, request.path)
+    cache_key = 'cache.decorators.cache_header.%s.%s' % (key_prefix, request.path)
     if response.has_header('Vary'):
         headerlist = ['HTTP_'+header.upper().replace('-', '_') for header in vary_delim_re.split(response['Vary'])]
         cache.set(cache_key, headerlist, cache_timeout)

=== renamed file 'django/views/decorators/cache.py' => 'django/cache/decorators.py'
--- django/views/decorators/cache.py	2006-12-19 04:35:09 +0000
+++ django/cache/decorators.py	2007-05-15 05:07:03 +0000
@@ -12,8 +12,8 @@
 """
 
 from django.utils.decorators import decorator_from_middleware
-from django.utils.cache import patch_cache_control, add_never_cache_headers
-from django.middleware.cache import CacheMiddleware
+from django.cache.utils import patch_cache_control, add_never_cache_headers
+from django.cache.middleware import CacheMiddleware
 
 cache_page = decorator_from_middleware(CacheMiddleware)
 

=== modified file 'django/cache/__init__.py'
--- django/core/cache/__init__.py	2006-12-19 04:35:09 +0000
+++ django/cache/__init__.py	2007-05-15 04:53:20 +0000
@@ -4,7 +4,7 @@
 This package defines set of cache backends that all conform to a simple API.
 In a nutshell, a cache is a set of values -- which can be any object that
 may be pickled -- identified by string keys.  For the complete API, see
-the abstract BaseCache class in django.core.cache.backends.base.
+the abstract BaseCache class in django.cache.backends.base.
 
 Client code should not access a cache backend directly; instead it should
 either use the "cache" variable made available here, or it should use the
@@ -17,7 +17,7 @@
 
 from cgi import parse_qsl
 from django.conf import settings
-from django.core.cache.backends.base import InvalidCacheBackendError
+from django.cache.backends.base import InvalidCacheBackendError
 
 BACKENDS = {
     # name for use in settings file --> name of module in "backends" directory
@@ -48,7 +48,7 @@
     if host.endswith('/'):
         host = host[:-1]
 
-    cache_class = getattr(__import__('django.core.cache.backends.%s' % BACKENDS[scheme], {}, {}, ['']), 'CacheClass')
+    cache_class = getattr(__import__('django.cache.backends.%s' % BACKENDS[scheme], {}, {}, ['']), 'CacheClass')
     return cache_class(host, params)
 
 cache = get_cache(settings.CACHE_BACKEND)

=== modified file 'django/cache/backends/db.py'
--- django/core/cache/backends/db.py	2006-12-19 04:35:09 +0000
+++ django/cache/backends/db.py	2007-05-15 04:52:13 +0000
@@ -1,6 +1,6 @@
 "Database cache backend."
 
-from django.core.cache.backends.base import BaseCache
+from django.cache.backends.base import BaseCache
 from django.db import connection, transaction, DatabaseError
 import base64, time
 from datetime import datetime

=== modified file 'django/cache/backends/dummy.py'
--- django/core/cache/backends/dummy.py	2007-01-15 02:57:49 +0000
+++ django/cache/backends/dummy.py	2007-05-15 04:52:08 +0000
@@ -1,6 +1,6 @@
 "Dummy cache backend"
 
-from django.core.cache.backends.base import BaseCache
+from django.cache.backends.base import BaseCache
 
 class CacheClass(BaseCache):
     def __init__(self, *args, **kwargs):

=== modified file 'django/cache/backends/filebased.py'
--- django/core/cache/backends/filebased.py	2006-12-19 04:35:09 +0000
+++ django/cache/backends/filebased.py	2007-05-15 04:52:02 +0000
@@ -1,6 +1,6 @@
 "File-based cache backend"
 
-from django.core.cache.backends.simple import CacheClass as SimpleCacheClass
+from django.cache.backends.simple import CacheClass as SimpleCacheClass
 import os, time, urllib
 try:
     import cPickle as pickle

=== modified file 'django/cache/backends/locmem.py'
--- django/core/cache/backends/locmem.py	2006-12-19 04:35:09 +0000
+++ django/cache/backends/locmem.py	2007-05-15 04:51:52 +0000
@@ -1,6 +1,6 @@
 "Thread-safe in-memory cache backend."
 
-from django.core.cache.backends.simple import CacheClass as SimpleCacheClass
+from django.cache.backends.simple import CacheClass as SimpleCacheClass
 from django.utils.synch import RWLock
 import copy, time
 

=== modified file 'django/cache/backends/memcached.py'
--- django/core/cache/backends/memcached.py	2007-03-28 01:14:50 +0000
+++ django/cache/backends/memcached.py	2007-05-15 04:51:47 +0000
@@ -1,6 +1,6 @@
 "Memcached cache backend"
 
-from django.core.cache.backends.base import BaseCache, InvalidCacheBackendError
+from django.cache.backends.base import BaseCache, InvalidCacheBackendError
 
 try:
     import cmemcache as memcache

=== modified file 'django/cache/backends/simple.py'
--- django/core/cache/backends/simple.py	2007-05-02 01:31:02 +0000
+++ django/cache/backends/simple.py	2007-05-15 04:51:43 +0000
@@ -1,6 +1,6 @@
 "Single-process in-memory cache backend."
 
-from django.core.cache.backends.base import BaseCache
+from django.cache.backends.base import BaseCache
 import time
 
 class CacheClass(BaseCache):

=== modified file 'django/conf/global_settings.py'
--- django/conf/global_settings.py	2007-05-14 15:26:10 +0000
+++ django/conf/global_settings.py	2007-05-15 04:50:42 +0000
@@ -273,7 +273,7 @@
 # CACHE #
 #########
 
-# The cache backend to use.  See the docstring in django.core.cache for the
+# The cache backend to use.  See the docstring in django.cache for the
 # possible values.
 CACHE_BACKEND = 'simple://'
 CACHE_MIDDLEWARE_KEY_PREFIX = ''

=== modified file 'django/contrib/admin/views/main.py'
--- django/contrib/admin/views/main.py	2007-05-02 01:31:02 +0000
+++ django/contrib/admin/views/main.py	2007-05-15 04:57:44 +0000
@@ -2,7 +2,7 @@
 from django.conf import settings
 from django.contrib.admin.filterspecs import FilterSpec
 from django.contrib.admin.views.decorators import staff_member_required
-from django.views.decorators.cache import never_cache
+from django.cache.decorators import never_cache
 from django.contrib.contenttypes.models import ContentType
 from django.core.exceptions import ImproperlyConfigured, ObjectDoesNotExist, PermissionDenied
 from django.core.paginator import ObjectPaginator, InvalidPage

=== modified file 'django/contrib/sessions/middleware.py'
--- django/contrib/sessions/middleware.py	2007-03-24 01:26:21 +0000
+++ django/contrib/sessions/middleware.py	2007-05-15 05:01:52 +0000
@@ -1,7 +1,7 @@
 from django.conf import settings
 from django.contrib.sessions.models import Session
 from django.core.exceptions import SuspiciousOperation
-from django.utils.cache import patch_vary_headers
+from django.cache.utils import patch_vary_headers
 import datetime
 
 TEST_COOKIE_NAME = 'testcookie'

=== modified file 'django/middleware/gzip.py'
--- django/middleware/gzip.py	2006-12-19 04:35:09 +0000
+++ django/middleware/gzip.py	2007-05-15 05:04:19 +0000
@@ -1,6 +1,6 @@
 import re
 from django.utils.text import compress_string
-from django.utils.cache import patch_vary_headers
+from django.cache.utils import patch_vary_headers
 
 re_accepts_gzip = re.compile(r'\bgzip\b')
 

=== modified file 'django/middleware/locale.py'
--- django/middleware/locale.py	2006-12-19 04:35:09 +0000
+++ django/middleware/locale.py	2007-05-15 05:04:26 +0000
@@ -1,6 +1,6 @@
 "this is the locale selecting middleware that will look at accept headers"
 
-from django.utils.cache import patch_vary_headers
+from django.cache.utils import patch_vary_headers
 from django.utils import translation
 
 class LocaleMiddleware(object):

=== modified file 'django/views/decorators/vary.py'
--- django/views/decorators/vary.py	2006-12-19 04:35:09 +0000
+++ django/views/decorators/vary.py	2007-05-15 05:02:59 +0000
@@ -1,4 +1,4 @@
-from django.utils.cache import patch_vary_headers
+from django.cache.utils import patch_vary_headers
 
 def vary_on_headers(*headers):
     """

=== modified file 'docs/cache.txt'
--- docs/cache.txt	2007-03-28 01:14:50 +0000
+++ docs/cache.txt	2007-05-15 04:49:37 +0000
@@ -294,11 +294,11 @@
 intensive database query. In cases like this, you can use the low-level cache
 API to store objects in the cache with any level of granularity you like.
 
-The cache API is simple. The cache module, ``django.core.cache``, exports a
+The cache API is simple. The cache module, ``django.cache``, exports a
 ``cache`` object that's automatically created from the ``CACHE_BACKEND``
 setting::
 
-    >>> from django.core.cache import cache
+    >>> from django.cache import cache
 
 The basic interface is ``set(key, value, timeout_seconds)`` and ``get(key)``::
 

=== modified file 'tests/regressiontests/cache/tests.py'
--- tests/regressiontests/cache/tests.py	2007-05-09 15:40:49 +0000
+++ tests/regressiontests/cache/tests.py	2007-05-15 04:50:12 +0000
@@ -1,7 +1,7 @@
 # Unit tests for cache framework
 # Uses whatever cache backend is set in the test settings file.
 
-from django.core.cache import cache
+from django.cache import cache
 import time, unittest
 
 # functions/classes for complex data type tests        